####################################################################################################
##     join & part
####################################################################################################

if {[namespace current] == "::"} {putlog "\002\00304You shouldn't use source for [info script]"; return}

set _name	{mjp}
pkg_add scr $_name "Buster <buster@buster-net.ru> (c)" "1.0.0" "15-Jan-2011" \
	"    join & part"

if {[pkg_info scr $_name on]} {
	
	################################################################################################
	#  ,      .
	set options(mjp_flag_ignore)		"o|m"
	
	################################################################################################
	#   ,  ,        (0 - ,
	# 1 - ).        ccs-mslaps_on_chan
	set options(mjp_on_chan)			0
	
	set options(mjp_joinpart_time)		5
	set options(mjp_joinpart_flood)		"4:10"
	set options(mjp_joinpart_banmask)	3
	
	setudef str ccs-mjp_on_chan
	setudef str ccs-mjp_joinpart_time
	setudef str ccs-mjp_joinpart_flood
	setudef str ccs-mjp_joinpart_banmask
	
	proc mjp_join {nick uhost hand chan} {
		variable mjp_join
		set mjp_join($chan,$nick) [clock seconds]
	}
	
	proc mjp_part {nick uhost hand schan text} {
		variable options
		variable mjp_join
		variable mjp_count
		
		if {![info exist mjp_join($schan,$nick)]} {
			return
		}
		
		set join_time $mjp_join($schan,$nick)
		unset mjp_join($schan,$nick)
		
		if {![get_options_int mjp_on_chan $schan]} {
			return
		}
		if {[check_matchattr $hand $schan $options(mjp_flag_ignore)]} {
			return
		}
		if {[expr [clock seconds] - $join_time] > [get_options_int mjp_joinpart_time $schan]} {
			return
		}
		
		lappend mjp_count($schan) [clock seconds]
		
		set mjp_count($schan) [lreplace $mjp_count($schan) 0 end-[lindex [split [get_options_str mjp_joinpart_flood $schan] :] 0]]
		
		if {[llength $mjp_count($schan)] < [lindex [split [get_options_str mjp_joinpart_flood $schan] :] 0]} {
			return
		}
		if {[expr [clock seconds] - [lindex $mjp_count($schan) 0]] > [lindex [split [get_options_str mjp_joinpart_flood $schan] :] 1]} {
			return
		}
		
		set banmask [::ccs::get_mask "$nick!$uhost" [get_options_int mjp_joinpart_banmask $schan]]
		putserv "MODE $schan +b $banmask"
		
		put_log -command "MASSJOINPART" -- "$nick!$uhost"
		
	}
	
	proc mjp_sign {nick uhost hand chan text} {
		mjp_part $nick $uhost $hand $chan $text
	}
	
	proc main_$_name {} {
		
		bind join - * [namespace origin mjp_join]
		bind part - * [namespace origin mjp_part]
		bind sign - * [namespace origin mjp_sign]
		
	}
	
}